com.io7m.r2.filters

## Class R2SSAOKernel

- java.lang.Object
- - com.io7m.r2.filters.R2SSAOKernel

- All Implemented Interfaces:
    R2SSAOKernelReadableType, R2SSAOKernelType, R2SSAOKernelWritableType

      public final class R2SSAOKernel
      extends Object
      implements R2SSAOKernelType

  The default implementation of the `R2SSAOKernelType` interface.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static com.io7m.jranges.RangeInclusiveI` | `VALID_SIZES` The range of valid kernel sizes.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `FloatBuffer` | `floatBuffer()`
    `static R2SSAOKernelType` | `newKernel(int in_size)` Generate a new kernel.
    `void` | `regenerate(int new_size)` Regenerate the kernel, using `s` samples.
    `void` | `sample(int index, com.io7m.jtensors.VectorWritable3FType out)`
    `int` | `size()`
    `long` | `version()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### VALID_SIZES

          public static final com.io7m.jranges.RangeInclusiveI VALID_SIZES

      The range of valid kernel sizes.

  - ### Method Detail

    - #### newKernel

          public static R2SSAOKernelType newKernel(int in_size)

      Generate a new kernel.
      Parameters:
        `in_size` - The kernel size
      Returns:
        A new kernel

    - #### regenerate

          public void regenerate(int new_size)

      Description copied from interface: `R2SSAOKernelWritableType`
      Regenerate the kernel, using `s` samples.
      Specified by:
        `regenerate` in interface `R2SSAOKernelWritableType`
      Parameters:
        `new_size` - The new size
      See Also:
        `VALID_SIZES`

    - #### sample

          public void sample(int index,
                             com.io7m.jtensors.VectorWritable3FType out)

      Specified by:
        `sample` in interface `R2SSAOKernelReadableType`
      Parameters:
        `index` - The sample index
        `out` - The output vector

    - #### version

          public long version()

      Specified by:
        `version` in interface `R2SSAOKernelReadableType`
      Returns:
        The number of times this kernel has been regenerated

    - #### size

          public int size()

      Specified by:
        `size` in interface `R2SSAOKernelReadableType`
      Returns:
        The number of samples in the kernel

    - #### floatBuffer

          public FloatBuffer floatBuffer()

      Specified by:
        `floatBuffer` in interface `R2SSAOKernelReadableType`
      Returns:
        The raw float buffer that backs the kernel

Copyright © 2017 <code@io7m.com> http://io7m.com